SystemOrganization addCategory: #'Kinect-OSC'!

KinectServer subclass: #KinectOSC
	instanceVariableNames: 'oscServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-OSC'!

!KinectOSC class methodsFor: 'as yet unclassified' stamp: 'Richo 9/11/2012 13:35'!
codeName
	^ #OSC! !

!KinectOSC methodsFor: 'starting' stamp: 'Richo 9/5/2012 17:47'!
isStarted
	^ oscServer notNil! !

!KinectOSC methodsFor: 'accessing' stamp: 'Richo 9/5/2012 17:36'!
jointNames 
^ {
	'head' -> #head.
	'neck' -> #shoulderCenter.
	'l_collar' -> #leftCollar. "not used"
	'l_shoulder' -> #shoulderLeft.
	'l_elbow' -> #elbowLeft.
	'l_wrist' -> #wristLeft. "not used"
	'l_hand' -> #handLeft.
	'l_fingertip' -> #leftFingertip. "not used"
	'r_collar' -> #rightCollar. "not used"
	'r_shoulder' -> #shoulderRight.
	'r_elbow' -> #elbowRight.
	'r_wrist' -> #wristRight. "not used"
	'r_hand' -> #handRight.
	'r_fingertip' -> #rightFingertip. "not used"
	'torso' -> #spine.
	'waist' -> #hipCenter. "not used"
	'l_hip' -> #hipLeft.
	'l_knee' -> #kneeLeft.
	'l_ankle' -> #ankleLeft. "not used"
	'l_foot' -> #footLeft.
	'r_hip' -> #hipRight.
	'r_knee' -> #kneeRight.
	'r_ankle' -> #ankleRight. "not used"
	'r_foot' -> #footRight
} as: Dictionary ! !

!KinectOSC methodsFor: 'event handling' stamp: 'Richo 9/5/2012 16:49'!
newPacket: aBundle
	aBundle do: [:msg | self parse: msg].! !

!KinectOSC methodsFor: 'parsing' stamp: 'Richo 9/5/2012 17:03'!
parse: msg
	| header |
	header := msg first.
	(header = '/joint')
		ifTrue: [^ self parseJoint: msg].
	(header = '/new_user')
		ifTrue: [^ self newUser: msg second].
	(header = '/lost_user')
		ifTrue: [^ self lostUser: msg second].
	(header = '/pose_detected')
		ifTrue: [^ self poseDetected: msg second].
	(header = '/calibration_start')
		ifTrue: [^ self calibrationStart: msg second].
	(header = '/new_skel')
		ifTrue: [^ self newSkeleton: msg second].
	! !

!KinectOSC methodsFor: 'parsing' stamp: 'Richo 9/11/2012 15:07'!
parseJoint: msg 
	| position jointName userId |
	msg size < 6
		ifTrue: [^ self].
	jointName := self jointNames at: msg second.
	userId := msg third.
	position := msg fourth @ msg fifth @ ((msg sixth / 3.5) min: 1).
	self jointUpdate: jointName
		position: position
		state: TrackingState tracked
		user: userId! !

!KinectOSC methodsFor: 'starting' stamp: 'Richo 9/5/2012 17:46'!
start
	self isStarted ifTrue: [^self].
	oscServer := OSCServer listenOnPort: 7110.
	oscServer when: #bundleReceived send: #newPacket: to: self! !

!KinectOSC methodsFor: 'starting' stamp: 'Richo 9/5/2012 17:46'!
stop
	self isStarted ifFalse: [^self].
	oscServer terminate.
	oscServer := nil.! !
